; procedure draws triangle with pixel precisely displacement;
; in:  xmm0 - normal vector 1st   vertex x y z
;      xmm1 - normal vector 2cond vertex x y z
;      xmm2 - normal vector 3rd   vertex x y z
;      eax  - x1 shl 16 + y1
;      ebx  - x2 shl 16 + y2
;      ecx  - x3 shl 16 + y3
;      edx  - zbuffer_ptr
;      esi  - Atexture_ptr
;      edi  - Btexture_ptr
;
; other parameters via stack
      .tax1 equ [ebp + 8]
      .tay1 equ [ebp + 10]
      .tbx1 equ [ebp + 12]
      .tby1 equ [ebp + 14]

      .tax2 equ [ebp + 16]
      .tay2 equ [ebp + 18]
      .tbx2 equ [ebp + 20]
      .tby2 equ [ebp + 22]


      .tax3 equ [ebp + 24]
      .tay3 equ [ebp + 26]
      .tbx3 equ [ebp + 28]
      .tby3 equ [ebp + 30]

      .z1   equ [ebp + 32]
      .z2   equ [ebp + 34]
      .z3   equ [ebp + 36]

      .screen_ptr equ dword[ebp+38]


	.texa_ptr equ	dword[ebp-4]	    ; pointer to texture
	.texb_ptr equ	dword[ebp-8]	    ; pointer to texture
	.z_ptr	  equ	dword[ebp-12]	    ; pointer to z-buffer
	.x1	  equ word[ebp-14]
	.y1	  equ word[ebp-16]
	.x2	  equ word[ebp-18]
	.y2	  equ word[ebp-20]
	.x3	  equ word[ebp-22]
	.y3	  equ word[ebp-24]

	.dx12  equ [ebp-28]   ;
	.dax12 equ [ebp-32]   ;
	.day12 equ [ebp-36]   ;
	.dbx12 equ [ebp-40]   ;   this deltas - fixed point
	.dby12 equ [ebp-44]   ;
	.dz12  equ [ebp-48]   ;
	.dx12  equ [ebp-52]   ;
	.dnz12 equ [ebp-56] ;
	.dny12 equ [ebp-60] ;  normal deltas as float
	.dnx12 equ [ebp-64] ;

	.dax13 equ [ebp-68]
	.day13 equ [ebp-72]
	.dbx13 equ [ebp-76]
	.dby13 equ [ebp-80]
	.dz13  equ [ebp-84]
	.dny13 equ [ebp-88]
	.dnx13 equ [ebp-92]
	.dnz13 equ [ebp-96]

	.dx23  equ [ebp-100]
	.dax23 equ [ebp-104]
	.day23 equ [ebp-108]
	.dbx23 equ [ebp-112]
	.dby23 equ [ebp-116]
	.dz23  equ [ebp-120]
	.dny23 equ [ebp-124]
	.dnx23 equ [ebp-128]
	.dnz23 equ [ebp-132]

	.cx1   equ [ebp-136]
	.cx2   equ [ebp-140]
	.cax1  equ [ebp-144]




; ?????????????? !!!!!!!!!!

	.cay1  equ [ebp-148]
	.cbx1  equ [ebp-148]
	.cbx1  equ [ebp-152]
	.cby2  equ [ebp-156]
	.cz1   equ [ebp-160]
	.cz2   equ [ebp-164]
	.cn1   equ [ebp-168]
	.cn2   equ [ebp-172]

	push  ebp
	mov   ebp,esp

	push  esi
	push  edi
	push  edx

     .sort3:
	cmp	 ax,bx
	jle	 .sort1
	xchg	 eax,ebx
	movaps	 xmm3,xmm0
	movaps	 xmm0,xmm1
	movaps	 xmm1,xmm3
	movq	 xmm4,.tax1
	movq	 xmm5,.tax2
	movq	 .tax2,xmm4
	movq	 .tax1,xmm5
	mov	 dx,.z1
	xchg	 dx,.z2
	mov	 .z1,dx
     .sort1:
	cmp	 bx,cx
	jle	 .sort2
	xchg	 ebx,ecx
	movaps	 xmm3,xmm1
	movaps	 xmm1,xmm2
	movaps	 xmm2,xmm3
	movq	 xmm4,.tax3
	movq	 xmm5,.tax2
	movq	 .tax2,xmm4
	movq	 .tax3,xmm5
	mov	 dx,.z3
	xchg	 dx,.z2
	mov	 .z3,dx
	jmp	 .sort3
      .sort2:

	push	 eax ebx ecx
	mov	 edx,80008000h
	and	 edx,eax
	and	 edx,ebx
	and	 edx,ecx
	test	 edx,80008000h
	jne	 .loop23_done

	mov	 bx,.y2
	sub	 bx,.y1
	jnz	 .dx12_make
	mov	 ecx,10
	xor	 edx,edx
     @@:
	push	 edx
	loop	 @b
	jmp	 .dx12_done
     .dx12_make:
	mov	 ax,x2
	sub	 ax,.x1
	cwde
	movsx	 ebx,bx
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tax2
	sub	 ax,.tax1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tay2
	sub	 ax,.tay1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tbx2
	sub	 ax,.tbx1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tby2
	sub	 ax,.tby1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.z2
	sub	 ax,.z1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	movaps	 xmm3,xmm1
  ;	 movaps   xmm4,xmm0
	subps	 xmm3,xmm0
	cvtsi2ss xmm5,ebx
	shufps	 xmm5,xmm5,0
	divps	 xmm3,xmm5
	movlps	 .dnx12,xmm3
	movhlps  xmm3,xmm3
	movss	 .dnz12,xmm3
	sub	 esp,12
     .dx12_done:

	mov	 bx,.y3
	sub	 bx,.y1
	jnz	 .dx13_make
	mov	 ecx,10
  ;	 xor	  edx,edx
     @@:
	push	 edx
	loop	 @b
	jmp	 .dx13_done
     .dx13_make:
	mov	 ax,x3
	sub	 ax,.x1
	cwde
	movsx	 ebx,bx
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tax3
	sub	 ax,.tax1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tay3
	sub	 ax,.tay1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tbx3
	sub	 ax,.tbx1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tby3
	sub	 ax,.tby1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.z3
	sub	 ax,.z1
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	movaps	 xmm3,xmm2
  ;	 movaps   xmm4,xmm0
	subps	 xmm3,xmm0
   ;	 cvtsi2ss xmm5,ebx
   ;	 shufps   xmm5,xmm5,0
	divps	 xmm3,xmm5
	movlps	 .dnx13,xmm3
	movhlps  xmm3,xmm3
	movss	 .dnz13,xmm3
	sub	 esp,12
     .dx13_done:

	mov	 bx,.y3
	sub	 bx,.y2
	jnz	 .dx23_make
	mov	 ecx,10
     @@:
	push	 edx
	loop	 @b
	jmp	 .dx23_done
     .dx23_make:
	mov	 ax,x3
	sub	 ax,.x2
	cwde
	movsx	 ebx,bx
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tax3
	sub	 ax,.tax2
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tay3
	sub	 ax,.tay2
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tbx3
	sub	 ax,.tbx2
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.tby3
	sub	 ax,.tby2
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	mov	 ax,.z3
	sub	 ax,.z2
	cwde
	shl	 eax,ROUND
	cdq
	idiv	 ebx
	push	 eax

	movaps	 xmm3,xmm2
	subps	 xmm3,xmm1
	divps	 xmm3,xmm5
	movlps	 .dnx23,xmm3
	movhlps  xmm3,xmm3
	movss	 .dnz23,xmm3
	sub	 esp,12
     .dx23_done:

	 movsx	 eax,.x1
	 shl	 eax,ROUND
	 push	 eax
	 push	 eax

	 movsx	 ebx,.tax1
	 shl	 ebx,ROUND
	 push	 ebx
	 movsx	 ecx,.tay1
	 shl	 ecx,ROUND
	 push	 ecx ebx eax
	 movsx	 edx,.z1
	 shl	 edx,ROUND
	 push	 edx
	 push	 edx
	 movd	 eax,xmm0
	 push	 eax
	 push	 eax

	 movsx	 ecx,.y1
	 cmp	 cx,.y2
	 jge	 loop12_done
	 call	 .call_line




